#define Channel_maxbuf 100

#include "Sema.h"
#include <pthread.h>

template<class T> class Channel
{ private:
    T buffer[Channel_maxbuf];
    int front, rear;
    pthread_mutex_t s_mux, r_mux;
    Sema *empty;
    Sema *full;
  public:
    Channel();
    ~Channel();
    void send(T);
    void receive(T*);
};
